## pgpool2 4.6.3

=== src/sql/pgpool_adm/Makefile ===
# contrib/pgpool_adm/Makefile

MODULE_big = pgpool_adm
OBJS = pgpool_adm.o
PG_CPPFLAGS = -I$(libpq_srcdir) -I../../include/pcp -DPGPOOL_ADM

EXTENSION = pgpool_adm
DATA = pgpool_adm--1.0.sql pgpool_adm--1.1.sql pgpool_adm--1.2.sql pgpool_adm--1.3.sql \
pgpool_adm--1.0--1.1.sql pgpool_adm--1.1--1.2.sql pgpool_adm--1.2--1.3.sql \
pgpool_adm--1.4.sql pgpool_adm--1.3--1.4.sql \
pgpool_adm--1.5.sql pgpool_adm--1.4--1.5.sql
SHLIB_LINK =  -L../../libs/pcp/.libs -lpcp -Wl,--as-needed -Wl,-rpath,'${prefix}/lib',--enable-new-dtags
# if you are using PostgreSQL 8.0 or later,
# using pg_config is recommended.
# if you are not, comment out following line and...
USE_PGXS = true
# set top_builddir to the PostgreSQL build source tree top.
# (for example /usr/local/src/postgresql-8.4)
top_builddir = ../..

ifdef USE_PGXS
PG_CONFIG ?= pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/pgpool_adm
#top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== src/test/C/Makefile ===
#
# Makefile for example programs
#

subdir = .
top_builddir = /usr/local/src/pgsql/current/pgsql
include $(top_builddir)/src/Makefile.global

ifeq ($(PORTNAME), win32)
LDLIBS += -lws2_32
endif

override CPPFLAGS := -I$(libpq_srcdir) $(CPPFLAGS)
override LDLIBS := $(libpq_pgport) $(LDLIBS)


PROGS = test_extended

all: $(PROGS)

clean: 
	rm -f $(PROGS)

=== src/test/parser/Makefile ===
# $Header$

PROGRAM=parser-test
PGPOOL_SRC=../../../src/parser
PARSER_INCLUDES=../../../src/include/parser
PARSER_OBJS=gram.o parser.o list.o makefuncs.o value.o nodes.o pool_memory.o main.o keywords.o outfuncs.o copyfuncs.o kwlookup.o scansup.o wchar.o

#ENABLE_GCOV=1

CFLAGS=-Wall -c -g -include pool.h -I. -I $(PARSER_INCLUDES)
CFLAGS+=-O0 -g -DPARSER_TEST
LDFLAGS=

ifdef ENABLE_GCOV
CFLAGS+= -fprofile-arcs -ftest-coverage
LDFLAGS+= -lgcov
GENHTML_OUTDIR=genhtml
endif

all: $(PROGRAM)

.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	gcc $(CFLAGS) $<

$(PROGRAM): $(PARSER_OBJS)
	gcc $(PARSER_OBJS) -o $(PROGRAM) $(LDFLAGS)

main.o: main.c

keywords.o: $(PGPOOL_SRC)/keywords.c
	gcc $(CFLAGS) $<

outfuncs.o: $(PGPOOL_SRC)/outfuncs.c
	gcc $(CFLAGS) $<

gram.o: gram.c scan.c
	gcc $(CFLAGS) $<

gram.c: $(PGPOOL_SRC)/gram.y scan.c
	bison -d $(PGPOOL_SRC)/gram.y
ifdef ENABLE_GCOV
	cp gram.tab.c gram.c
	cp gram.tab.h gram.h
else
	mv -f gram.tab.c gram.c
	mv -f gram.tab.h gram.h
endif

parser.o : $(PGPOOL_SRC)/parser.c
	gcc $(CFLAGS) $<

list.o : $(PGPOOL_SRC)/list.c
	gcc $(CFLAGS) $<

makefuncs.o : $(PGPOOL_SRC)/makefuncs.c
	gcc $(CFLAGS) $<

value.o : $(PGPOOL_SRC)/value.c
	gcc $(CFLAGS) $<

nodes.o : $(PGPOOL_SRC)/nodes.c
	gcc $(CFLAGS) $<

scansup.o : $(PGPOOL_SRC)/scansup.c
	gcc $(CFLAGS) $<

scan.c : $(PGPOOL_SRC)/scan.l
	flex -o$@ $<

pool_memory.o: $(PGPOOL_SRC)/pool_memory.c $(PARSER_INCLUDES)/pool_memory.h
	gcc $(CFLAGS) $<

copyfuncs.o: $(PGPOOL_SRC)/copyfuncs.c
	gcc $(CFLAGS) $<

kwlookup.o: $(PGPOOL_SRC)/kwlookup.c
	gcc $(CFLAGS) $<

wchar.o: $(PGPOOL_SRC)/wchar.c
	gcc $(CFLAGS) $<

test: $(PROGRAM)
	./run-test parse_schedule

cov:
	test -d $(GENHTML_OUTDIR) || mkdir $(GENHTML_OUTDIR)
	lcov --directory . --capture --output-file $(PROGRAM).info
	genhtml -o $(GENHTML_OUTDIR) -f $(PROGRAM).info

clean-cov:
ifdef ENABLE_GCOV
	rm -f *.gcda *.gcno
	rm -f parser-test.info
	rm -rf $(GENHTML_OUTDIR)
endif

clean: clean-cov
	rm -f $(PROGRAM)
	rm -f *.o
	rm -f gram.c scan.c gram.h
	rm -f gram.tab.c gram.tab.h

.PHONY: all test clean-cov clean cov

=== debian/changelog ===
pgpool2 (4.6.3-3) unstable; urgency=medium

  * Upload for PostgreSQL 18. (Closes: #1117306)
  * debian/pgversions: PG10 is supported, bool fixed on the PG side.
  * Add ${postgresql:Breaks}.
  * debian/tests: Depend on postgresql-common-dev instead of 'make'.

 -- Christoph Berg <myon@debian.org>  Thu, 09 Oct 2025 13:17:02 +0200

pgpool2 (4.6.3-2) unstable; urgency=medium

  * Fix FTBFS with gcc-15. (Closes: #1097576)
  * debian/pgversions: Bump to 11+.

 -- Christoph Berg <myon@debian.org>  Tue, 09 Sep 2025 15:15:13 +0200

pgpool2 (4.6.3-1) unstable; urgency=medium

  * New upstream version 4.6.3.

 -- Christoph Berg <myon@debian.org>  Fri, 29 Aug 2025 10:09:44 +0200

=== debian/control ===
Source: pgpool2
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
 Marco Nenciarini <mnencia@debian.org>,
 Adrian Vondendriesch <adrian.vondendriesch@credativ.de>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit <!pkg.postgresql.32-bit>,
 bison,
 chrpath,
 docbook,
 docbook-dsssl,
 docbook-xml,
 docbook-xsl,
 flex,
 libldap-dev,
 libmemcached-dev,
 libpam0g-dev,
 libpq-dev,
 libssl-dev,
 libxml2-utils,
 openjade,
 opensp,
 postgresql-server-dev-all,
 xsltproc,
Standards-Version: 4.7.2
Homepage: https://www.pgpool.net/mediawiki/index.php/Main_Page
Vcs-Git: https://salsa.debian.org/postgresql/pgpool2.git
Vcs-Browser: https://salsa.debian.org/postgresql/pgpool2

Package: pgpool2
Architecture: kfreebsd-any linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libpgpool2 (= ${binary:Version}),
 postgresql-common,
 ucf,
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 postgresql,
Conflicts:
 pgpool,
Replaces:
 pgpool,
Description: connection pool server and replication proxy for PostgreSQL
 pgpool-II is a middleware that works between PostgreSQL servers and a
 PostgreSQL database client. It provides the following features:
 .
  * Connection Pooling
  * Replication
  * Load Balance
  * Limiting Exceeding Connections
  * Parallel Query
 .
 pgpool-II talks PostgreSQL's backend and frontend protocol, and relays a
 connection between them. Therefore, a database application (frontend) thinks
 that pgpool-II is the actual PostgreSQL server, and the server (backend) sees
 pgpool-II as one of its clients. Because pgpool-II is transparent to both the
 server and the client, an existing database application can be used with
 pgpool-II almost without a change to its sources.
 .
 This is version 3 of pgpool-II, the second generation of pgpool.

Package: libpgpool2
Architecture: kfreebsd-any linux-any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: pgpool control protocol library
 pgpool-II is a middleware that works between PostgreSQL servers and a
 PostgreSQL database client.  This package contains the pgpool control
 protocol library (libpcp).

Package: libpgpool-dev
Architecture: kfreebsd-any linux-any
Section: libdevel
Depends:
 libpgpool2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
# We also provide /usr/lib/libpcp.{a,so}
Conflicts:
 libpcp3-dev,
Description: pgpool control protocol library - headers
 pgpool-II is a middleware that works between PostgreSQL servers and a
 PostgreSQL database client.  This package contains headers for the pgpool
 control protocol library (libpcp).

Package: postgresql-18-pgpool2
Architecture: kfreebsd-any linux-any
Depends:
 libpgpool2 (>= ${binary:Version}),
 postgresql-18,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 ${postgresql:Breaks},
Description: connection pool server and replication proxy for PostgreSQL - modules
 pgpool-II is a middleware that works between PostgreSQL servers and a
 PostgreSQL database client.  This package contains support modules for
 the PostgreSQL 18 server:
 .
  * pgpool_adm
  * pgpool_recovery (PostgreSQL 9.1 and above)
  * pgpool_regclass (PostgreSQL 9.1 and above)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/postgresql-common/pgxs_debian_control.mk

LDFLAGS += -Wl,--as-needed

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C src/sql clean
	rm -f config.log
	$(MAKE) -C src/sql/pgpool_adm clean USE_PGXS=1
	rm -rf src/test/jdbc/*.class src/test/jdbc/result src/test/jdbc/pgpool.properties
	# tests disabled because they have been broken in commit cdb49d3
	#$(MAKE) -C src/test/parser clean
	#rm -rf src/test/parser/result src/test/parser/test.diff
	#$(MAKE) -C src/test/timestamp clean
	#rm -rf src/test/timestamp/result src/test/timestamp/test.diff
	cd src/test/regression && bash clean.sh
	rm -rf debian/postgresql-*-pgpool2/ debian/*.substvars

override_dh_auto_configure:
	./configure --prefix=/usr \
		--sysconfdir=/etc/pgpool2 \
		--bindir=/usr/sbin \
		--includedir=/usr/include/pgpool2 \
		--disable-rpath \
		--with-ldap \
		--with-openssl \
		--with-pam \
		--with-memcached=/usr/include/libmemcached
	# create directory here so we can unlink it in case autopkgtest leaves files owned by root behind
	mkdir -p src/test/jdbc/result

override_dh_auto_build:
	$(MAKE)
	$(MAKE) -C doc

override_dh_auto_test:
	dh_auto_test
	# tests disabled because they have been broken in commit cdb49d3
	#$(MAKE) -C src/test/parser test
	#chmod +x src/test/timestamp/run-test
	#$(MAKE) -C src/test/timestamp test
	# src/test/jdbc is executed by autopkgtest

override_dh_auto_install:
	dh_auto_install
	set -e ; \
	for v in `pg_buildext supported-versions .` ; do \
		echo "# $$v ##################################################################" ; \
		PG_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config ; \
		$(MAKE) -C src/sql clean PG_CONFIG=$$PG_CONFIG ; \
		$(MAKE) -C src/sql PG_CONFIG=$$PG_CONFIG ; \
		chrpath -d src/sql/pgpool_adm/pgpool_adm.so ; \
		$(MAKE) -C src/sql install DESTDIR=$(CURDIR)/debian/postgresql-$$v-pgpool2 PG_CONFIG=$$PG_CONFIG ; \
	done

override_dh_install:
	# pgpool.conf is handled by ucf
	mkdir -p debian/tmp/usr/share/pgpool2
	mv debian/tmp/etc/pgpool2/pgpool.conf.sample debian/tmp/usr/share/pgpool2/pgpool.conf
	set -e ; for f in pcp.conf pool_hba.conf ; do mv debian/tmp/etc/pgpool2/$$f.sample debian/tmp/etc/pgpool2/$$f ; done
	rm debian/tmp/usr/lib/libpcp.la # not interested in .la
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs NEWS

execute_before_dh_installdocs:
	sed -i -e "s/CONTENT=\"20..-..-..T..:..:..\"/CONTENT=\"$(shell date -ud "@$$SOURCE_DATE_EPOCH" "+%Y-%m-%dT%H:%M:%S")\"/" doc/src/sgml/html/*.html

%:
	dh $@

=== debian/tests/control ===
Depends:
 default-jdk,
 libpostgresql-jdbc-java,
 locales-all,
 postgresql,
 postgresql-common-dev,
 @,
Restrictions:
 needs-root,
 skip-not-installable,
Tests:
 jdbc-tests,

Depends:
 postgresql-common (>= 217~),
 postgresql-common-dev,
 @,
Restrictions:
 allow-stderr,
Tests:
 installcheck,

=== debian/watch ===
version=4
opts=filenamemangle=s/.*=(.*)/$1/ \
http://www.pgpool.net/mediawiki/index.php/Downloads .*pgpool-II-([0-9.]+).tar.gz

## pgpool2 4.6.4

=== debian/changelog ===
pgpool2 (4.6.4-1.pgdg25.10+1) questing-pgdg; urgency=medium

  * Rebuild for questing-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Thu, 27 Nov 2025 09:40:39 +0100

pgpool2 (4.6.4-1) unstable; urgency=medium

  * New upstream version 4.6.4.

 -- Christoph Berg <myon@debian.org>  Thu, 27 Nov 2025 09:40:39 +0100

pgpool2 (4.6.3-4) unstable; urgency=medium

  * Add libcrypt-dev to Build-Depends. (Closes: #1107004)

 -- Christoph Berg <myon@debian.org>  Fri, 21 Nov 2025 12:03:44 +0100

## pgpool2 4.6.5

=== src/sql/pgpool_adm/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 pgpool_adm--1.0--1.1.sql pgpool_adm--1.1--1.2.sql pgpool_adm--1.2--1.3.sql \
 pgpool_adm--1.4.sql pgpool_adm--1.3--1.4.sql \
 pgpool_adm--1.5.sql pgpool_adm--1.4--1.5.sql
-SHLIB_LINK =  -L../../libs/pcp/.libs -lpcp -Wl,--as-needed -Wl,-rpath,'${prefix}/lib',--enable-new-dtags
+SHLIB_LINK =  -L../../libs/pcp/.libs -lpcp
 # if you are using PostgreSQL 8.0 or later,
 # using pg_config is recommended.
 # if you are not, comment out following line and...

=== debian/changelog ===
pgpool2 (4.6.5-1.pgdg25.10+1) questing-pgdg; urgency=medium

  * Rebuild for questing-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 16 Dec 2025 12:04:51 +0100

pgpool2 (4.6.5-1) unstable; urgency=medium

  * New upstream version 4.6.5.

 -- Christoph Berg <myon@debian.org>  Tue, 16 Dec 2025 12:04:51 +0100

## pgpool2 4.7.0

=== src/sql/pgpool_adm/Makefile ===
--- 
+++ 
@@ -8,7 +8,8 @@
 DATA = pgpool_adm--1.0.sql pgpool_adm--1.1.sql pgpool_adm--1.2.sql pgpool_adm--1.3.sql \
 pgpool_adm--1.0--1.1.sql pgpool_adm--1.1--1.2.sql pgpool_adm--1.2--1.3.sql \
 pgpool_adm--1.4.sql pgpool_adm--1.3--1.4.sql \
-pgpool_adm--1.5.sql pgpool_adm--1.4--1.5.sql
+pgpool_adm--1.5.sql pgpool_adm--1.4--1.5.sql \
+pgpool_adm--1.6.sql pgpool_adm--1.5--1.6.sql
 SHLIB_LINK =  -L../../libs/pcp/.libs -lpcp
 # if you are using PostgreSQL 8.0 or later,
 # using pg_config is recommended.

=== debian/changelog ===
pgpool2 (4.7.0-1) unstable; urgency=medium

  * New upstream version 4.7.0.

 -- Christoph Berg <myon@debian.org>  Thu, 25 Dec 2025 15:10:20 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
  docbook-xml,
  docbook-xsl,
  flex,
+ libcrypt-dev,
  libldap-dev,
  libmemcached-dev,
  libpam0g-dev,

## pgpool2 4.7.1

=== src/sql/pgpool_adm/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 pgpool_adm--1.4.sql pgpool_adm--1.3--1.4.sql \
 pgpool_adm--1.5.sql pgpool_adm--1.4--1.5.sql \
 pgpool_adm--1.6.sql pgpool_adm--1.5--1.6.sql
-SHLIB_LINK =  -L../../libs/pcp/.libs -lpcp
+SHLIB_LINK =  -L../../libs/pcp/.libs -lpgpoolpcp
 # if you are using PostgreSQL 8.0 or later,
 # using pg_config is recommended.
 # if you are not, comment out following line and...

=== debian/changelog ===
pgpool2 (4.7.1-1) unstable; urgency=medium

  * New upstream version 4.7.1.
  * Rename libpgpool2 to libpgpoolpcp3. Upstream renamed the files not to
    conflict with libpcp. We had been avoiding the conflict by calling the
    package libpgpool even when it contained libpcp (with a lower SONAME than
    the other libpcp.)

 -- Christoph Berg <myon@debian.org>  Thu, 26 Feb 2026 09:49:43 +0100

=== debian/control ===
--- 
+++ 
@@ -37,17 +37,13 @@
 Pre-Depends:
  ${misc:Pre-Depends},
 Depends:
- libpgpool2 (= ${binary:Version}),
+ libpgpoolpcp3 (= ${binary:Version}),
  postgresql-common,
  ucf,
  ${misc:Depends},
  ${shlibs:Depends},
 Enhances:
  postgresql,
-Conflicts:
- pgpool,
-Replaces:
- pgpool,
 Description: connection pool server and replication proxy for PostgreSQL
  pgpool-II is a middleware that works between PostgreSQL servers and a
  PostgreSQL database client. It provides the following features:
@@ -67,7 +63,7 @@
  .
  This is version 3 of pgpool-II, the second generation of pgpool.
 
-Package: libpgpool2
+Package: libpgpoolpcp3
 Architecture: kfreebsd-any linux-any
 Section: libs
 Depends:
@@ -82,12 +78,9 @@
 Architecture: kfreebsd-any linux-any
 Section: libdevel
 Depends:
- libpgpool2 (= ${binary:Version}),
+ libpgpoolpcp3 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
-# We also provide /usr/lib/libpcp.{a,so}
-Conflicts:
- libpcp3-dev,
 Description: pgpool control protocol library - headers
  pgpool-II is a middleware that works between PostgreSQL servers and a
  PostgreSQL database client.  This package contains headers for the pgpool
@@ -96,7 +89,7 @@
 Package: postgresql-18-pgpool2
 Architecture: kfreebsd-any linux-any
 Depends:
- libpgpool2 (>= ${binary:Version}),
+ libpgpoolpcp3 (>= ${binary:Version}),
  postgresql-18,
  ${misc:Depends},
  ${shlibs:Depends},
@@ -108,5 +101,5 @@
  the PostgreSQL 18 server:
  .
   * pgpool_adm
-  * pgpool_recovery (PostgreSQL 9.1 and above)
-  * pgpool_regclass (PostgreSQL 9.1 and above)
+  * pgpool_recovery
+  * pgpool_regclass

=== debian/rules ===
--- 
+++ 
@@ -60,7 +60,7 @@
 	mkdir -p debian/tmp/usr/share/pgpool2
 	mv debian/tmp/etc/pgpool2/pgpool.conf.sample debian/tmp/usr/share/pgpool2/pgpool.conf
 	set -e ; for f in pcp.conf pool_hba.conf ; do mv debian/tmp/etc/pgpool2/$$f.sample debian/tmp/etc/pgpool2/$$f ; done
-	rm debian/tmp/usr/lib/libpcp.la # not interested in .la
+	rm -vf debian/tmp/usr/lib/libpgpoolpcp.la # not interested in .la
 	dh_install
 
 override_dh_installchangelogs:
